//
// jot - Text Editor for Windows Mobile
//   Copyright (C) 2007-2008, Aquamarine Networks.  <http://pandora.sblo.jp/>
//
//    This program is EveryOne's ware; you can redistribute it and/or modify it 
//    under the terms of the NYSL version 0.9982 or later. <http://www.kmonos.net/nysl/>
//

#pragma once
#include	"BottomBar.h"
#include	"jot.h"
#include	"editor.h"

// CFindBar
#define	ID_FB_EDIT	40000

class CFindBar : public CBottomBar
{
	DECLARE_DYNAMIC(CFindBar)

	CStatic	m_label;
	CEditor	m_edit;
	CString	m_title;

public:
	CFindBar();
	virtual ~CFindBar();

	virtual	void	CreateContents(){
		m_title.LoadString( IDS_FIND );
		m_label.Create( m_title , WS_VISIBLE|WS_CHILD  , CRect(0,0,0,0) ,this );
		m_edit.Create( WS_VISIBLE|WS_CHILD|WS_BORDER
					, CRect(0,0,0,0) , this , ID_FB_EDIT );
	
		MakeMenu( IDR_FIND );
	}
	virtual	int		Layout(){
		CRect rect;
		GetClientRect(&rect);

		CDC	*pDc = GetDC();
		CSize sz = pDc->GetTextExtent( m_title );
		ReleaseDC(pDc);
		
		// x
		CRect	lrect(0,4,sz.cx,sz.cy+4);
		m_label.MoveWindow( lrect );

		// GfBbgRg[
		int	eh = sz.cy *15 /10;
		CRect	erect(lrect.right +1 , 1, rect.right - 1 , eh+1 );
		m_edit.MoveWindow( erect );
		
		return eh+7;
	}
	virtual	void	EnterKey()
	{
		PostMessage( WM_COMMAND , ID_FIND , 0 );
	}
	virtual	void	SetFocusItem()
	{
		m_edit.SetFocus();
	}

protected:
	DECLARE_MESSAGE_MAP()
	afx_msg void OnFind();
	afx_msg void OnUpdateFind(CCmdUI *pCmdUI);
	afx_msg void OnFindUp();
	afx_msg void OnUpdateFindUp(CCmdUI *pCmdUI);
};


