//
// jot - Text Editor for Windows Mobile
//   Copyright (C) 2007-2008, Aquamarine Networks.  <http://pandora.sblo.jp/>
//
//    This program is EveryOne's ware; you can redistribute it and/or modify it 
//    under the terms of the NYSL version 0.9982 or later. <http://www.kmonos.net/nysl/>
//

#include "StdAfx.h"
#include "MruList.h"

CMruList::CMruList(int max)
{
	m_max = max;
}

CMruList::~CMruList(void)
{
}

POSITION	CMruList::GetPosition( const TCHAR *filename ){
	for( POSITION pos = m_list.GetHeadPosition();pos!=NULL; ){
		POSITION ret = pos;
		CMru mru = m_list.GetNext(pos);
		if ( mru.filename.CompareNoCase( filename ) == 0 ){
			return ret;
		}
	}
	return NULL;
}

void	CMruList::Add( const TCHAR*filename , int p )
{
	if ( *filename == _T('\0') )
		return;
	// ڍ폜
	Remove( filename );
	// 擪ɒǉ
	CMru	mru( filename ,p );
	m_list.AddHead( mru );
}

void	CMruList::AddTail( const TCHAR*filename , int p )
{
	if ( *filename == _T('\0') )
		return;
	// ڍ폜
	Remove( filename );
	// 擪ɒǉ
	CMru	mru( filename ,p );
	m_list.AddTail( mru );
}


void	CMruList::Remove( const TCHAR*filename )
{
	POSITION pos = GetPosition( filename );
	// Xgɂꍇ폜
	if ( pos != NULL ){		
		m_list.RemoveAt( pos );
	}
	// TCYĂ镪폜
	while( m_list.GetCount()>=m_max ){
		m_list.RemoveTail();
	}
}
